#!/bin/sh
USBKBD_RCSID='$Revision: 12379 $ $Date:: 2011-10-15 16:54:09 +0300 #$'

# geninitrd mod: usbkbd

# setup geninitrd module
# @access	public
setup_mod_usbkbd() {
	:
}

find_modules_usbkbd() {
	debug "Finding USB keyboard modules"

	if [ "$(echo /sys/class/input/input*)" = "/sys/class/input/input*" ]; then
		return
	fi

	local modules i module bInterfaceClass bInterfaceProtocol

	for i in /sys/class/input/input*; do
		[ ! -f $i/device/bInterfaceClass -o ! -f $i/device/bInterfaceProtocol ] && continue
		bInterfaceClass=$(cat $i/device/bInterfaceClass)
		bInterfaceProtocol=$(cat $i/device/bInterfaceProtocol)
		if [ "$bInterfaceClass" = "03" -a "$bInterfaceProtocol" = "01" ]; then
			module=$(readlink $i/device/driver/module)
			module=$(basename $module)

			if [ -n "$module" ]; then
				debug "Found USB Keyboard: $(cat $i/name)"
				modules="$modules $module"
			fi
		fi
	done

	if [ -n "$modules" ]; then
		# usb controllers
		for m in $(find_modules_by_class "0c03"); do
			find_module $m
		done

		for m in $modules; do
			find_module $m
		done
	fi
}
